<?php 

if( ! defined( "DB_FUNCTIONS_TEMPLATES" ) )
	include( "./includes/db_functions_templates.php" );

//if( ! defined("GENERIC_TRACER_CLASS") )
//	include( "./Tracer/generic_tracer.class.php" );
//
//$tracer = new Tracer("/tmp/trace.log");
//$tracer->setTracingActive( false );

// Spalten-Info
$columns      = $_POST[ "columns"        ];
$getter       = $_POST[ "getter"         ];
$setter       = $_POST[ "setter"         ];
$treatment    = $_POST[ "treatment"      ];
$primaryKey   = $_POST[ "primary"        ];
$setInsert    = $_POST[ "setinsert"      ];
$setUpdate    = $_POST[ "setupdate"      ];
$setUpdateNow = $_POST[ "setnowonupdate" ];
$setInsertNow = $_POST[ "setnowoninsert" ];

// DB-Info
$databaseHost  = $_POST[ "dbhost"  ];
$databaseUser  = $_POST[ "dbuser"  ];
$databasePass  = $_POST[ "dbpass"  ];
$database      = $_POST[ "db"      ];
$databaseTable = $_POST[ "dbtable" ];

// Klassen-Info
$nameOfClass   = $_POST[ "clName" ];

Header( "Content-Disposition: attachment; filename=$nameOfClass.class.php" );
//Header( "Content-type: text/plain" );
Header( "Content-type: application/x-httpd-php-source;" );


echo "<?php\n\n";
echo "/**\n";
echo "A class representig a single dataset in the\n";
echo "database <code>$database</code> and the table <code>$databaseTable</code>.\n";
echo "*/\n";
echo "class $nameOfClass\n";
echo "{\n\n";

echo getConstructor( $nameOfClass, $databaseHost, $databaseUser, $databasePass, $database, $databaseTable );
echo "\n\n";

echo getInitializer( $columns, $treatment );
echo "\n\n";

foreach( $columns as $col )
{
	
	$gName = $getter[ "$col" ];
	$sName = $setter[ "$col" ];
	
	$colTreatment = $treatment[ "$col" ];
	
	//$tracer->trace( "column: $col" );
	//$tracer->trace( "treat as: $colTreatment" );
	
	switch( $colTreatment )
	{
		
		// Fall 1:
		case "bool":
		{
			$gTyp = GETTER_TYPE_BOOLEAN;
			$sTyp = SETTER_TYPE_BOOLEAN;
			break;
		}
		
		case "integer":
		{
			$gTyp = GETTER_TYPE_INTEGER;
			$sTyp = SETTER_TYPE_INTEGER;
			break;
		}
		
		case "string":
		{
			$gTyp = GETTER_TYPE_STRING;
			$sTyp = SETTER_TYPE_STRING;
			break;
		}
		
		case "stamp":
		{
			$gTyp = GETTER_TYPE_TIMESTAMP;
			$sTyp = SETTER_TYPE_TIMESTAMP;
			break;
		}
		
		// Fallback:
		default:
		{
			break;
		}
	}
	/*
	echo "<pre>";
	echo nl2br( htmlentities( getGetter( $gName, $gTyp, $col ) ) );
	echo "<br><br>";
	echo nl2br( htmlentities( getSetter( $sName, $sTyp, $col ) ) );
	echo "<br><br>";
	echo "</pre>";
	*/
	
	echo getGetterDocTemplate( $col, $colTreatment );
	echo getGetter( $gName, $gTyp, $col );
	echo getSetterDocTemplate( $col, $colTreatment );
	echo getSetter( $sName, $sTyp, $col );
	
}

//$tracer->trace( "Loader: primary is $primaryKey" );

echo getLoaderDocTemplate();
echo getLoader( $primaryKey, $columns, $databaseTable, $treatment );

echo getUpdaterDocTemplate();
echo getUpdater( $primaryKey, $columns, $databaseTable, $treatment, $setUpdate, $setUpdateNow );

echo getInserterDocTemplate();
echo getInserter( $primaryKey,  $columns, $databaseTable, $treatment, $setInsert, $setInsertNow );

echo getSyncerDocTemplate();
echo getSyncer( $primaryKey, $treatment );

echo getDeleterDocTemplate();
echo getDeleter( $primaryKey, $databaseTable, $treatment );

echo "\n\n";
echo "}";
echo "\n\n?>";


?>
