<?php 

// DOCUMENT: Listet alle Tabellen auf
// AUTHOR: M.Beranek <marcus@beranek.de>
// DATE: DD.MM.YYYY
// COPYRIGHT: M.Beranek

// Fehlermeldungen abschalten:
error_reporting(0);

// bergebene Parameter:
$databaseHost = $_POST[ "dbhost" ];
$databaseUser = $_POST[ "dbuser" ];
$databasePass = $_POST[ "dbpass" ];
$database     = $_POST[ "db" ];

// Wenn keine Werte via POST gesetzt wurden, akzeptieren wir auch GET-Werte:
if( empty($databaseHost) ) $databaseHost = $_GET[ "dbhost" ];
if( empty($databaseUser) ) $databaseUser = $_GET[ "dbuser" ];
if( empty($databasePass) ) $databasePass = $_GET[ "dbpass" ];
if( empty($database) )     $database     = $_GET[ "db" ];

// Parameter fr Back-Link
$backParams = "dbhost=".urlencode( $databaseHost )
	."&amp;dbuser=".urlencode( $databaseUser )
	."&amp;dbpass=".urlencode( $databasePass )
	."&amp;db=".urlencode( $database );

// Parameter fr Back-URL
$backParamsURL = "dbhost=".urlencode( $databaseHost )
	."&dbuser=".urlencode( $databaseUser )
	."&dbpass=".urlencode( $databasePass )
	."&db=".urlencode( $database );
	
// Zunchst eine Verbindung zu MySQL aufbauen:
mysql_connect( $databaseHost, $databaseUser, $databasePass );

// Fehler abfangen:
if( mysql_errno() )
{
	/*
	echo "<div class='error'>".htmlentities(mysql_error() )."</div>";
	exit();
	*/
	$backLink = "./db.php?$backParamsURL";
	Header( "Status: 307" );
	Header( "Location: error.php?back=".urlencode($backLink)."&err=".urlencode( mysql_error() ) );
	exit;
}

// Alle Tabellen auslesen.
$tableListResource = mysql_query( "SHOW TABLES FROM ".addslashes($database) );

// Fehler abfangen:
if( mysql_errno() )
{
	/*
	echo "<div class='error'>".htmlentities(mysql_error() )."</div>";
	exit();
	*/
	$backLink = "./db.php?$backParamsURL";
	Header( "Status: 307" );
	Header( "Location: error.php?back=".urlencode($backLink)."&err=".urlencode( mysql_error() ) );
	exit;
} 

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" 
	"http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
	<title></title>
	<link type="text/css" href="./styles/default.css" rel="stylesheet">
	</head>
	<body>
	<div id="navitop"><div class='navicontent'><a href="./db.php?<?php echo $backParams; ?>">Back</a></div></div>
	<div id="content">
	<h1><?php echo htmlentities($databaseUser); ?>@<?php echo htmlentities($databaseHost); ?>: <?php echo htmlentities($database); ?>.tables</h1>
<?php 

// Tabellen ausgeben:
while( $tableEntry = mysql_fetch_row( $tableListResource ) )
{
	// Datanbankname
	$table = $tableEntry[0];
	
	$generatorUrl = "./generator.php?dbhost=".urlencode($databaseHost)
		."&amp;dbuser="	.urlencode($databaseUser)
		."&amp;dbpass="	.urlencode($databasePass)
		."&amp;db=".urlencode($database)
		."&amp;dbtable=".urlencode($table);
	echo "<div><a href='$generatorUrl'>".htmlentities( $table )."</a></div>";
	
}

?>
</div>
<div id="navibottom"><div class='navicontent'><a href="./db.php?<?php echo $backParams; ?>">Back</a></div></div>
</body>
</html>
